function K = centering(K)

% K = centering(K)
%
% Center a quadratic Gram matrix or a kernel matrix to one
% corresponding to column centered observations

% Allan Asbjerg Nielsen 2010
% aa@space.dtu.dk

[n p] = size(K);
if n ~= p
    error('input matrix must be quadratic')
end

% % K symmetric
% % (Shawe-Taylor & Cristianini, 2004, p. 115)
% D = sum(K)/n;
% E = sum(D)/n;
% J = ones(n,1)*D;
% K = K-J-J'+E;%*ones(ntrain,ntrain);

% K non-symmetric
D = sum(K)/n;
E = sum(D)/n;
J1 = ones(n,1)*D;
J2 = sum(K,2)*ones(1,n)/n;
K = K-J1-J2+E;%*ones(n,n);

% % centering the kernel matrix to zero mean
% % (Bishop, 2006, p. 589)
% % elegant but takes way too long time for large n
% N = ones(n)/n;
% K = K - N*K - K*N + N*K*N;
