function [X, P, L, r]  = sqrtmsvd(A, tol)

%sqrtmsvd     Matrix square root via SVD.
%
%   x = sqrtmsvd(A) is the principal square root of the matrix A, i.e. X*X = A.
%
%   See also sqrtm, expm, logm, funm, rank.

% Allan Aasbjerg Nielsen, 2008-2010

% A = A-repmat(mean(A), size(A,1), 1);
% nsv = 100; % # of singular values - a form of regularization
% [P, L, V] = svds(A, nsv);
[P, L, V] = svd(A);
diagL = diag(L);
if nargin==1
   tol = max(size(A)') * eps(max(diagL));
end
r = sum(diagL > tol);
% r = rank(A, tol);
P = P(:,1:r);
L = sqrt(diagL(1:r));
% L = sqrt(diag(L(1:r,1:r)));
X = P*diag(L)*P';
